- [HTTP request](https://docs.cloud.google.com/dialogflow/cx/docs/reference/rest/v3/projects.locations.agents.environments.sessions/fulfillIntent#body.HTTP_TEMPLATE)
- [Path parameters](https://docs.cloud.google.com/dialogflow/cx/docs/reference/rest/v3/projects.locations.agents.environments.sessions/fulfillIntent#body.PATH_PARAMETERS)
- [Request body](https://docs.cloud.google.com/dialogflow/cx/docs/reference/rest/v3/projects.locations.agents.environments.sessions/fulfillIntent#body.request_body)
  - [JSON representation](https://docs.cloud.google.com/dialogflow/cx/docs/reference/rest/v3/projects.locations.agents.environments.sessions/fulfillIntent#body.request_body.SCHEMA_REPRESENTATION)
    - [JSON representation](https://docs.cloud.google.com/dialogflow/cx/docs/reference/rest/v3/projects.locations.agents.environments.sessions/fulfillIntent#body.request_body.SCHEMA_REPRESENTATION.match_intent_request.SCHEMA_REPRESENTATION)
    - [JSON representation](https://docs.cloud.google.com/dialogflow/cx/docs/reference/rest/v3/projects.locations.agents.environments.sessions/fulfillIntent#body.request_body.SCHEMA_REPRESENTATION.match_intent_request.SCHEMA_REPRESENTATION_1)
- [Response body](https://docs.cloud.google.com/dialogflow/cx/docs/reference/rest/v3/projects.locations.agents.environments.sessions/fulfillIntent#body.response_body)
- [Authorization scopes](https://docs.cloud.google.com/dialogflow/cx/docs/reference/rest/v3/projects.locations.agents.environments.sessions/fulfillIntent#body.aspect)
- [Try it!](https://docs.cloud.google.com/dialogflow/cx/docs/reference/rest/v3/projects.locations.agents.environments.sessions/fulfillIntent#try-it)

Fulfills a matched intent returned by `https://docs.cloud.google.com/dialogflow/cx/docs/reference/rest/v3/projects.locations.agents.sessions/matchIntent#google.cloud.dialogflow.cx.v3.Sessions.MatchIntent`. Must be called after `https://docs.cloud.google.com/dialogflow/cx/docs/reference/rest/v3/projects.locations.agents.sessions/matchIntent#google.cloud.dialogflow.cx.v3.Sessions.MatchIntent`, with input from `https://docs.cloud.google.com/dialogflow/cx/docs/reference/rest/v3/MatchIntentResponse`. Otherwise, the behavior is undefined.

### HTTP request

Choose an endpoint:
global   
`POST https://dialogflow.googleapis.com/v3/{matchIntentRequest.session=projects/*/locations/*/agents/*/environments/*/sessions/*}:fulfillIntent`

<br />

The URLs use [gRPC Transcoding](https://google.aip.dev/127) syntax.

**OR**

`POST https://{endpoint}/v3/{matchIntentRequest.session=projects/*/locations/*/agents/*/environments/*/sessions/*}:fulfillIntent`

Where `{endpoint}` is one of the [supported service endpoints](https://docs.cloud.google.com/dialogflow/cx/docs/reference/rest#rest_endpoints).

The URLs use [gRPC Transcoding](https://google.aip.dev/127) syntax.

### Path parameters

| Parameters ||
|---|---|
| `matchIntentRequest.session` | `string` Required. The name of the session this query is sent to. Format: `projects/<ProjectID>/locations/<LocationID>/agents/<AgentID>/sessions/<SessionID>` or `projects/<ProjectID>/locations/<LocationID>/agents/<AgentID>/environments/<EnvironmentID>/sessions/<SessionID>`. If `Environment ID` is not specified, we assume default 'draft' environment. It's up to the API caller to choose an appropriate `Session ID`. It can be a random number or some type of session identifiers (preferably hashed). The length of the `Session ID` must not exceed 36 characters. For more information, see the [sessions guide](https://cloud.google.com/dialogflow/cx/docs/concept/session). Authorization requires the following [IAM](https://cloud.google.com/iam/docs/) permission on the specified resource `session`: - `dialogflow.sessions.detectIntent` |

### Request body

The request body contains data with the following structure:

| JSON representation |
|---|
| ``` { "matchIntentRequest": { "session": string, "queryParams": { "timeZone": string, "geoLocation": { object (`https://docs.cloud.google.com/dialogflow/cx/docs/reference/rest/v3/QueryParameters#LatLng`) }, "sessionEntityTypes": [ { object (`https://docs.cloud.google.com/dialogflow/cx/docs/reference/rest/v3/projects.locations.agents.environments.sessions.entityTypes#SessionEntityType`) } ], "payload": { object }, "parameters": { object }, "parameterScope": string, "currentPage": string, "disableWebhook": boolean, "analyzeQueryTextSentiment": boolean, "webhookHeaders": { string: string, ... }, "flowVersions": [ string ], "currentPlaybook": string, "llmModelSettings": { object (`https://docs.cloud.google.com/dialogflow/cx/docs/reference/rest/v3/LlmModelSettings`) }, "channel": string, "sessionTtl": string, "endUserMetadata": { object }, "searchConfig": { object (`https://docs.cloud.google.com/dialogflow/cx/docs/reference/rest/v3/QueryParameters#SearchConfig`) }, "populateDataStoreConnectionSignals": boolean }, "queryInput": { "languageCode": string, // The following is a list of mutually exclusive fields. At most one of the // fields will be set in a response: "text": { object (`https://docs.cloud.google.com/dialogflow/cx/docs/reference/rest/v3/ConversationTurn#TextInput`) }, "intent": { object (`https://docs.cloud.google.com/dialogflow/cx/docs/reference/rest/v3/ConversationTurn#IntentInput`) }, "audio": { object (`https://docs.cloud.google.com/dialogflow/cx/docs/reference/rest/v3/ConversationTurn#AudioInput`) }, "event": { object (`https://docs.cloud.google.com/dialogflow/cx/docs/reference/rest/v3/ConversationTurn#EventInput`) }, "dtmf": { object (`https://docs.cloud.google.com/dialogflow/cx/docs/reference/rest/v3/ConversationTurn#DtmfInput`) }, "toolCallResult": { object (`https://docs.cloud.google.com/dialogflow/cx/docs/reference/rest/v3/ConversationTurn#ToolCallResult`) } // End of mutually exclusive fields. }, "persistParameterChanges": boolean }, "match": { object (`https://docs.cloud.google.com/dialogflow/cx/docs/reference/rest/v3/Match`) }, "outputAudioConfig": { object (`https://docs.cloud.google.com/dialogflow/cx/docs/reference/rest/v3/OutputAudioConfig`) } } ``` |

| Fields ||
|---|---|
| `matchIntentRequest.queryParams` | ``object (`https://docs.cloud.google.com/dialogflow/cx/docs/reference/rest/v3/QueryParameters`)`` The parameters of this query. |
| `matchIntentRequest.queryInput` | ``object (`https://docs.cloud.google.com/dialogflow/cx/docs/reference/rest/v3/ConversationTurn#QueryInput`)`` Required. The input specification. |
| `matchIntentRequest.persistParameterChanges` | `boolean` Persist session parameter changes from `queryParams`. |
| `match` | ``object (`https://docs.cloud.google.com/dialogflow/cx/docs/reference/rest/v3/Match`)`` The matched intent/event to fulfill. |
| `outputAudioConfig` | ``object (`https://docs.cloud.google.com/dialogflow/cx/docs/reference/rest/v3/OutputAudioConfig`)`` Instructs the speech synthesizer how to generate output audio. |

### Response body

If successful, the response body contains an instance of `https://docs.cloud.google.com/dialogflow/cx/docs/reference/rest/v3/FulfillIntentResponse`.

### Authorization scopes

Requires one of the following OAuth scopes:

- `https://www.googleapis.com/auth/cloud-platform`
- `
  https://www.googleapis.com/auth/dialogflow`

For more information, see the [Authentication Overview](https://docs.cloud.google.com/docs/authentication#authorization-gcp).